from typing import TYPE_CHECKING

from api.v1.common.base_models import TenantScopedMixin, TimestampMixin
from core.database import Base
from sqlalchemy import (
    Boolean,
    ForeignKeyConstraint,
    Integer,
    PrimaryKeyConstraint,
    SmallInteger,
    UniqueConstraint,
)
from sqlalchemy.orm import Mapped, mapped_column, relationship

if TYPE_CHECKING:
    from api.v1.modules.a76.pedmientos.models.pedimentos import Pedimentos


class PedimentoConfigSurcharges(Base, TenantScopedMixin, TimestampMixin):
    __tablename__ = "pedimento_config_surcharges"
    __table_args__ = (
        PrimaryKeyConstraint("id", name="pedimento_config_surcharges_pkey"),        
        ForeignKeyConstraint(
            ["pedimento_id"],
            ["a76.pedimentos.id"],
            ondelete="CASCADE",
            name="fk_pedimento_config_surcharges",
        ),
        UniqueConstraint(
            "tenant_id",
            "company_id",
            "pedimento_id",
            name="pedimento_config_surcharges_pedimento_id_key",
        ),
        {"schema": "a76"},
    )

    id: Mapped[int] = mapped_column(Integer)
    pedimento_id: Mapped[int] = mapped_column(Integer, nullable=False)

    surcharge_igi: Mapped[bool] = mapped_column(Boolean)
    surcharge_dta: Mapped[bool] = mapped_column(Boolean)
    surcharge_vat: Mapped[bool] = mapped_column(Boolean)
    surcharge_isan: Mapped[bool] = mapped_column(Boolean)
    surcharge_ieps: Mapped[bool] = mapped_column(Boolean)
    surcharge_cc: Mapped[bool] = mapped_column(Boolean)

    pedimento: Mapped["Pedimentos"] = relationship(
        "Pedimentos", back_populates="pedimento_config_surcharges"
    )
